//+------------------------------------------------------------------+
//|                                  Cycle_Identifier Indicator      |
//+------------------------------------------------------------------+

#property copyright  "Cycle_Identifier"
#property link       " "

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 LightGray

#property indicator_color2 Green
#property indicator_color3 Red

#property indicator_minimum -1.0
#property indicator_maximum  1.0

extern double  Length   = 8.25; 
    
int  PriceActionFilter  = 1;    
int  UseFilterSMAorRSI  = 1;     
int  FilterStrengthSMA  = 10;     
int  FilterStrengthRSI  = 21;   

double LineBuffer[];
double CI_Buy[];  
double CI_Sell[]; 
double ZL1[];

double CyclePrice = 0.0, Strength =0.0, Sweep = 0.0;
int Switch = 0, Switch2 = 0,	SwitchA = 0, SwitchB = 0, SwitchC = 0, SwitchD = 0;

bool UseCycleFilter = TRUE;

double PriceBuyA = 0.0;
int PriceBuyB = 0.0; 

double PriceSellA = 0.0;
int PriceSellB = 0.0;  

bool ActiveSwitch = True, BuySwitch = FALSE, SellSwitch = FALSE;
int BuySellFac = 01; 

bool Condition;

string Global_CI_string;
int CI = 0;

//----
int init()  
{
   string short_name;
   
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(0,LineBuffer);
   
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,5);
   SetIndexBuffer(1,CI_Buy); 
   
   
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,5);
   SetIndexBuffer(2,CI_Sell); 
   
   SetIndexStyle(3,DRAW_NONE); 
   SetIndexBuffer(3,ZL1);

   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);  
   
   short_name = "CI";
   
   Global_CI_string  = Symbol() + "_Global_CI";

   return(0);
}

//----
int deinit() {return(0);}

//----
int start() {
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   int position=Bars-counted_bars;
   if (position<0) position=0;

   int rnglength = 500;
   double range = 0.0, srange = 0.0;
      //Alert(Symbol() + "   pos = " + position + " Bars= " + Bars + " counted_bars= " + counted_bars);
   for (int pos = position; pos >=0; pos--)
   {

      srange = 0.0;
      int j = 0;
      for (int i=0;i<rnglength;i++)
      {
         j++;
         int posr = pos + i;
         if (posr >= Bars)
            break;
            
         srange = srange + (High[posr] - Low[posr]);
      }
      range = srange / j * Length;
      int BarNumber = Bars-pos; 
      if (BarNumber < 0)
            BarNumber = 0;
 
      CyclePrice = iMA(NULL, 0, PriceActionFilter, 0, MODE_SMMA, PRICE_WEIGHTED, pos); // PRICE_CLOSE
      
      if (UseFilterSMAorRSI == 1)
            ZL1[pos] = ZeroLag(CyclePrice,FilterStrengthSMA, pos);
      
      if (UseFilterSMAorRSI == 2)
            ZL1[pos] = ZeroLag( iRSI(NULL, 0, 14, CyclePrice, FilterStrengthRSI ), FilterStrengthRSI, pos);

      if (ZL1[pos] > ZL1[pos+1]) 
            SwitchC = 1;
      
      if (ZL1[pos] < ZL1[pos+1]) 
            SwitchC = 2;
          
      if (BarNumber <= 1)
      {
         if (Strength == 0)
     		   Sweep = range;
     		else
     		      Sweep      = Strength;
               PriceBuyA  = CyclePrice;
               PriceSellA = CyclePrice;
      }
      
      /* ***************************************************************** */
          
      if (BarNumber > 1)
      {
         if (Switch > -1) 
         {
            if (CyclePrice < PriceBuyA)
            {
                  if (UseCycleFilter && (SwitchC == 2) && BuySwitch)
                  {
			           CI_Buy[pos + BarNumber - PriceBuyB] = 0; 
			         }
		      
		            if (!UseCycleFilter && BuySwitch)
		            {
			           CI_Buy[pos +BarNumber - PriceBuyB] = 0; 
		            }
		            PriceBuyA = CyclePrice;
                  PriceBuyB = BarNumber;
                  BuySwitch = TRUE;
            }
            
            else if (CyclePrice > PriceBuyA)
            {
   			      SwitchA = BarNumber - PriceBuyB;
         
		            if (!UseCycleFilter)
		            {
			           CI_Buy[pos +SwitchA] = -1; 
		            }
		      
		            if (UseCycleFilter && SwitchC == 1)
		            {
			           CI_Buy[pos +SwitchA] = -1; 
			           SwitchD = 1; 
		            }
		            else
		              SwitchD = 0;
			         			   
                  BuySwitch = TRUE;
		            double cyclePrice1 = iMA(NULL, 0, PriceActionFilter, 0, MODE_SMMA, PRICE_WEIGHTED, pos + SwitchA); // EMA
                  if (ActiveSwitch)
                  {  
                     Condition = CyclePrice - cyclePrice1 >= Sweep; 
                  }
                  else
                  {
                     Condition = CyclePrice >= cyclePrice1 * (1 + Sweep / 1000);
                  }
                  if (Condition && SwitchA >= BuySellFac) 
                  {
                        Switch     = - 1;
                        PriceSellA = CyclePrice;
                        PriceSellB = BarNumber;
                        SellSwitch = FALSE;
                        BuySwitch  = FALSE;
                  }            
            }
         }
         
         if(Switch < 1) 
         {
            if (CyclePrice > PriceSellA)
            {
               if (UseCycleFilter && SwitchC == 1 && SellSwitch )
               {
				     CI_Sell[pos +BarNumber - PriceSellB] = 0; 
			      }
			      if (!UseCycleFilter && SellSwitch)
			      {
                 CI_Sell[pos +BarNumber - PriceSellB] = 0; 
               }
                     PriceSellA = CyclePrice;
                     PriceSellB = BarNumber;
                     SellSwitch = TRUE;   
		       }
		       
		       else if (CyclePrice < PriceSellA)
		       {
			      SwitchA = BarNumber - PriceSellB;
               if (!UseCycleFilter)
               {
                 CI_Sell[pos +SwitchA] = 1; 
			      }
      			if (UseCycleFilter && (SwitchC == 2))
      			{
				     CI_Sell[pos + SwitchA] = 1; 
				     SwitchD = 2;
			      } 
			      else
			        SwitchD = 0;

               SellSwitch = TRUE;
			      double cyclePrice2 = iMA(NULL, 0, PriceActionFilter, 0, MODE_SMMA, PRICE_WEIGHTED, pos + SwitchA);
               
			      if (ActiveSwitch)
				     Condition = (cyclePrice2 - CyclePrice) >= Sweep;
			      else 
				     Condition = CyclePrice <= (cyclePrice2 * (1 - Sweep / 1000));

			      if (Condition && SwitchA >= BuySellFac)
			      {  
				         Switch     = 1;
                     PriceBuyA  = CyclePrice;
                     PriceBuyB  = BarNumber;
                     SellSwitch = FALSE;
                     BuySwitch  = FALSE;
               }
            } 
         }
       }
       
       if (CI_Buy[pos] == -1) 
         {
            CI = 1;
            //GlobalVariableSet (Global_CI_string, CI); 
         }
               
       if (CI_Sell[pos] == 1) 
         {    
            CI = -1;
            //GlobalVariableSet (Global_CI_string, CI); 
         }
              
       LineBuffer[pos] = 0;
       //CI_Buy[pos]     = 0;  
       //CI_Sell[pos]    = 0;  
   }
      if (CI != 0)
         {
            GlobalVariableSet (Global_CI_string, CI);
         }
   return(0);
}

double ZeroLag(double price, int length, int pos)
{   
   if (length < 3) 
   {
      return(price);
   }
   
   double aa = MathExp(-1.414 * 3.14159 / length); 
   double bb = 2*aa*MathCos(1.414 * 180 / length); 
   double CB = bb;
   double CC = -aa * aa;
   double CA = 1 - CB - CC;
   double CD = CA*price + CB*ZL1[pos+1] + CC*ZL1[pos+2];
   
   return(CD);
}
   